
;	RUN80.ASM
;	As of December 27, 1987
;	8080 Emulator for 8088
;
;This program expects the Seattle Computer Products 8086
;assembler to be used to assemble it. Alternately, the
;Hawthorne Technology 8086 assembler can be used which is
;compatible to SASM.
;Or you can modify the program to work with MASM.
;The original cpemulator program was written in SASM which
;is why it is still in that assmebly style, besides which
;SASM is about ten times faster than MASM on small files 
;like this.


	ORG 100H
;
NO	EQU 0000H
YES	EQU 0FFFFH

NOTREENTER EQU YES	;YES=NORMAL EM, NO=RENTER OLD PRG

EMADM3	EQU NO		;YES=EMULATE ADM3 IN CODE

CR	EQU 0DH
LF	EQU 0AH
BELL	EQU 07H	


RAMSEGMENT	EQU 300H	;3000H  12K FOR EMULATOR

;
; SET UP ALL VARIABLES FOR EMULATOR
; DO ALL ONE TIME INITILIZATION
;
;	INITALIZATION SECTION
;
	JMP INIT

ATRIB:	DB 0FH

CPMMSG:
	DB '8080 CPeMulator  Version 3.01  as of December  27, 1987 ',CR,LF 
	DB 'Copyright (C) 1984,1987   Michael Day ',CR,LF
	DB 'To run a program, type -> RUN80 FILENAME  at the MSDOS prompt.',CR,LF
	DB '$'

; BEG OF PROGRAM

INIT:
	MOV SP,STACK
	MOV AX,CS
	MOV DS,AX
;


	JMP INITMORE		;NOW GO SETUP EMULATOR


USERBOOT:
	INT 20H		;RETURN TO MSDOS


;OUTPUT CONTROL ROUTINES

     IF EMADM3
CURCONT:
	CMP DL,00H	;IGNORE NULLS
	JZ CURBYPASS

	MOV AL,[EQFLAG]		;WE GOT AN ESC IS IT CURSOR CONT?
	CMP AL,0FFH
	JZ GETROW
	CMP DL,'='
	JNZ CLRCURFLG
	MOV B,[EQFLAG],0FFH
CURBYPASS:
	RET

GETROW:
	MOV AL,[ROWFLAG]
	CMP AL,0FFH
	JZ GETCOL
	SUB DL,32
	INC DL
	MOV [ROWCNT],DL
	MOV B,[ROWFLAG],0FFH
	RET

GETCOL:
	SUB DL,32
	MOV DH,[ROWCNT]
	MOV AH,2
	MOV AL,0
	MOV BX,0
	INT 10H

CLRCURFLG:
	MOV B,[CURFLAG],00H
	MOV B,[EQFLAG],00H
	MOV B,[ROWFLAG],00H
	RET
     ENDIF

;
GETSCREEN:
     IF EMADM3
	AND DL,7FH		;ESC SEQUENCE?
	CMP B,[CURFLAG],0FFH
	JZ CURCONT

	CMP DL,00H		;NULL?
	JZ GETSCEXIT
	CMP DL,1BH		;ESC CHAR
	JZ SETESC
	CMP DL,1AH		;CLEAR SCREEN
	JZ CLEARSCX
	CMP DL,1EH		;HOME
	JZ SETHOMEX
	CMP DL,0BH		;CURSOR UP?
	JZ CURSORUPX
	CMP DL,17H		;CLEAR END OF SCREEN
	JZ CLREOSX
	CMP DL,18H		;CLEAR EOL
	JZ CLREOLX

	CMP DL,0CH		;CURSOR RIGHT?
	JNZ CHAROUTOK
	JMP CURRIGHT

GETSCEXIT:
	RET

CLEARSCX:
	JMP CLEARSC

SETHOMEX:
	JMP SETHOME

CURSORUPX:
	JMP CURSORUP

CLREOSX:
	JMP CLREOS

CLREOLX:
	JMP CLREOL


SETESC:
	MOV B,[CURFLAG],0FFH
	RET
     ENDIF

CHAROUTOK:
     IF EMADM3
	PUSH DX
	MOV AH,3	;FIND OUT WHERE WE ARE AT
	MOV AL,0
	MOV BX,0
	INT 10H
	MOV [LASTXY],DX
	POP DX
     ENDIF

	MOV AH,06		;NORMAL CHAR
	INT 21H

     IF EMADM3
	MOV AH,3
	MOV AL,0
	MOV BX,0
	INT 10H

	MOV BX,[LASTXY]
	CMP DH,0
	JZ FIXROW 
	CMP DH,24
	JC NOERASETOP
	CMP BH,24
	JC NOERASETOP
	CMP DL,0
	JZ ERASETOP
	CMP DL,BL
	JZ ERASETOP
NOERASETOP:
	RET
ERASETOP:
	MOV AH,7	;ERASE THE TOP LINE ON THE SCREEN
	MOV AL,0
	MOV CX,0
	MOV DH,0
	MOV DL,79
	SEG CS
	MOV BH,[ATRIB]
	INT 10H
	RET

FIXROW:
	MOV DH,1	;OFFSET BACK TO LINE 1 IF WAS AT 0
	MOV AH,2
	MOV AL,0
	MOV BX,0
	INT 10H
	RET
     ENDIF

	RET

     IF EMADM3
CLREOL:	MOV AH,3
	MOV AL,0
	MOV BX,0
	INT 10H
	MOV AL,0
	MOV AH,6
	SEG CS
	MOV BH,[ATRIB]
	MOV CX,DX
	MOV DL,79
	INT 10H
	RET

CLREOS:	CALL CLREOL
	MOV AH,3
	MOV AL,0
	MOV BX,0
	INT 10H
	MOV AH,6
	SEG CS
	MOV BH,[ATRIB]
	MOV AL,0
	MOV CX,DX
	INC CH
	MOV CL,0
	MOV DH,24
	MOV DL,79
	INT 10H
	RET

CLEARSC:
	MOV AH,6
	MOV AL,0
	MOV CX,0
	MOV DH,24
	MOV DL,79
	SEG CS
	MOV BH,[ATRIB]
	INT 10H		;FALL THRU TO SETHOME

SETHOME:
	MOV AH,2
	MOV AL,0
	MOV DH,0
	MOV DL,0
	INC DH		;LINE 1 IS TOP OF PAGE IF BLANK TOP 	
	MOV BX,0
	INT 10H
	RET

CURSORUP:
	MOV AH,3
	MOV AL,0
	MOV BX,0
	INT 10H
	DEC DH
	CMP DH,0
	JNZ ROWUPOK
	INC DH

ROWUPOK:
	MOV AH,2
	MOV AL,0
	MOV BX,0
	INT 10H
	RET


CURRIGHT:
	MOV AL,0
	MOV AH,3
	MOV BX,0
	INT 10H
	INC DL
	CMP DL,80
	JC CURROK
	DEC DL
CURROK:
	MOV AH,2
	MOV AL,0
	MOV BX,0
	INT 10H
	RET
     ENDIF

;
GETKEYST:

	CMP B,[BYTERDYFLG],00H
	JNZ HAVENOW

	MOV AH,06H
	MOV DL,0FFH
	INT 21H
	CMP AL,00H
	JZ NOTREADY
	AND AL,7FH
	MOV [BYTEIN],AL
	MOV [GETIN],AL

HAVENOW:
	MOV AL,0FFH
	MOV [BYTERDYFLG],AL
	MOV [STRDY],AL
	JMP DKEYSTX
NOTREADY:
	MOV AL,00H
DKEYSTX:
	OR AL,AL
	RET


GETCOMMST:
	CMP B,[COMBRDYFLG],00H
	JNZ HAVECOMNOW
	MOV AH,03H
	MOV DX,0
	INT 14H
	AND AL,01H
	JZ NOTREADY
	MOV AH,02H
	MOV DX,0
	INT 14H
	AND AL,7FH
	MOV [COMBYTEIN],AL
	MOV [GETIN],AL
	JMP HAVECOMNOW

HAVECOMNOW:
	MOV AL,0FFH
	MOV [COMBRDYFLG],AL
	MOV [STRDY],AL
	JMP DKEYSTX

;
GETKEYIN:
	CMP B,[BYTERDYFLG],00H
	JNZ GOTALREADY
	CALL GETKEYST
	JMP GETKEYIN

GOTALREADY:
	MOV B,[STRDY],00H
	MOV B,[BYTERDYFLG],00H
	MOV AL,[BYTEIN]
	RET


GETCOMMIN:
	CMP B,[COMBRDYFLG],00H
	JNZ GOTCOMMNOW
	CALL GETCOMMST
	JMP GETCOMMIN
GOTCOMMNOW:
	MOV B,[STRDY],00H
	MOV B,[COMBRDYFLG],00H
	MOV AL,[COMBYTEIN]
	RET


GETCOMMOUT:
	MOV AH,01H
	MOV AL,DL
	MOV DX,0
	INT 14H
	RET

GETPRINOUT:
	MOV AH,05H
	INT 21H
	RET

;
;OUTPUT A BYTE TO THE CONSOLE
;
BCONOT:
	AND DL,7FH
	CMP B,[CONFLAG],00H
	JZ NOTBDCONOT
	CALL DIRCONCHK
	CMP AL,00H
	JNZ NOTBDCONOT
	CALL STOPCHECK
	RET

NOTBDCONOT:
	CALL DOBCONOT
	CALL STOPCHECK
	RET

DOBCONOT:
	MOV AL,[03H]
	AND AL,03H
	JZ SCREEN
	CMP AL,01H
	JZ COMMOUT
	CMP AL,02H
	JZ PRINOUT
	CALL COMMOUT
	JMP SCREEN

;GET A BYTE FROM THE CONSOLE
;
BCONIN:
	CMP B,[CONFLAG],00H
	JZ DOBCONIN
	CALL DOBCONIN
	JMP DIRCINCHK 

DOBCONIN:
	MOV AL,[03H]
	AND AL,03H
	JZ KEYIN
	CMP AL,01H
	JZ COMMIN
	CMP AL,02H
	JZ COMMIN
	CALL KEYST
	OR AL,AL
	JNZ KEYIN
	JMP COMMIN


BCONST:
	MOV AL,[03H]
	AND AL,03H
	JZ KEYST
	CMP AL,01H
	JZ COMMST
	CMP AL,02H
	JZ COMMST
	CALL COMMST
	MOV AH,AL
	PUSH AX
	CALL KEYST
	POP AX
	OR AL,AH
	RET

KEYST:
	JMP GETKEYST
COMMST:
	JMP GETCOMMST
KEYIN:
	JMP GETKEYIN
COMMIN:
	JMP GETCOMMIN
SCREEN:
	JMP GETSCREEN
COMMOUT:
	JMP GETCOMMOUT
PRINOUT:
	JMP GETPRINOUT

BRDIN:
	MOV AL,[03H]
	AND AL,0CH
	JZ KEYIN
	CMP AL,04H
	JZ COMMIN
	CMP AL,08H
	JZ KEYIN
	JMP COMMIN

BPUNOUT:
	MOV AL,[03H]
	AND AL,30H
	JZ SCREEN
	CMP AL,10H
	JZ COMMOUT
	CMP AL,20H
	JZ PRINOUT
	JMP COMMOUT


BLISTOUT:
	MOV AL,[03H]
	AND AL,0C0H
	JZ SCREEN
	CMP AL,040H
	JZ COMMOUT
	CMP AL,080H
	JZ PRINOUT
	JMP COMMOUT


STOPCHECK:
	PUSH DX
	CALL BCONST
	CMP B,[STRDY],00H
	JZ NOSTPCHR
	CMP B,[GETIN],'S'-40H
	JNZ NOSTPCHR
	CALL BCONIN	;CLEAR THIS CHR
	CALL BCONIN	;WAIT FOR NEXT ONE
NOSTPCHR:
	POP DX
	RET

;
DIRCONCHK:
	CMP DL,00H
	JZ IGNOREOUT
	CMP DL,7FH
	JZ IGNOREOUT
	CMP DL,'I'-40H
	JNZ CONOUTOK

TABOUTLP:
	MOV DL,' '
	CALL BCONOT
	MOV AL,[SPCOUNT]
	AND AL,07H
	JNZ TABOUTLP

IGNOREOUT:
	MOV AL,00H
	RET

CONOUTOK:
	CMP DL,0DH
	JNZ INCSPC1
	MOV B,[SPCOUNT],00H
	JMP CONTSPC

DECSPC:
	CMP B,[SPCOUNT],00H
	JZ CONTSPC
	DEC B,[SPCOUNT]
	JMP CONTSPC

INCSPC1:
	CMP DL,'H'-40H
	JZ DECSPC
	CMP DL,' '
	JC CONTSPC
	CMP DL,7FH
	JZ CONTSPC
	INC B,[SPCOUNT]
CONTSPC:
	CMP B,[PRTFLAG],0FFH
	JNZ NOPRTOUT
	PUSH DX
	CALL BLISTOUT
	POP DX
NOPRTOUT:
	MOV AL,0FFH
	RET

DIRCINCHK:
	CMP AL,7FH
	JZ NOCINECHO
	CMP AL,'H'-40H
	JZ CINECHO
	CMP AL,'I'-40H
	JZ CINECHO
	CMP AL,'J'-40H
	JZ CINECHO
	CMP AL,'M'-40H
	JZ CINECHO
	CMP AL,' '
	JC NOCINECHO
CINECHO:
	PUSH DX
	PUSH AX
	MOV DL,AL
	CALL BCONOT
	POP AX
	POP DX
NOCINECHO:
	RET

;
; END OF INSTALLATION SECTION
;
;
; SIMULATE CP/M CALLS WITH MS DOS CALLS
;
MACROED:
	ADD SI,2
	XOR BX,BX
	MOV BL,[SI-1]
	MOV AL,BL

	CMP BL,MAXMAC
	JNC Z80MACERR
	SAL BX
	SEG CS
	JMP [MACTABLE+BX]

Z80MACERR:
	JMP Z80ED

MACTABLE:
	DW RBDOS	;0  00H
	DW USERBOOT  	;1  01H
	DW USERBOOT	;2  02H
	DW JCONST	;3  03H
	DW JCONIN	;4  04H
	DW JCONOUT	;5  05H
	DW JLIST	;6  06H
	DW JPUNCH	;7  07H
	DW JREADER	;8  08H
	DW JHOME	;9  09H
	DW JSELDSK	;10 0AH	
	DW JSETTRK	;11 0BH
	DW JSETSEC	;12 0CH
	DW JSETDMA	;13 0DH
	DW JREAD	;14 0EH
	DW JWRITE	;15 0FH
	DW JLISTST	;16 10H
	DW JSECTRAN	;17 11H
	DW Z80MACERR	;18 12H

MAXMAC:	EQU 18

JCONST:
	MOV B,[CONFLAG],00H
	CALL BCONST
	MOV [IA],AL
	OR AL,AL
	JMP DONE

JCONIN:
	MOV B,[CONFLAG],00H
	CALL BCONIN
	MOV [IA],AL
	JMP DONE

JCONOUT:
	MOV B,[CONFLAG],00H
	MOV DL,[IC]
	CALL BCONOT
	JMP DONE

JLIST:
	MOV DL,[IC]
	MOV B,[CONFLAG],00H
	CALL BLISTOUT
	JMP DONE

JPUNCH:
	MOV DL,[IC]
	MOV B,[CONFLAG],00H
	CALL BPUNOUT
	JMP DONE

JREADER:
	MOV B,[CONFLAG],00H
	CALL BRDIN
	MOV [IA],AL
	JMP DONE

JHOME:
	MOV AH,00H
	INT 13H
	JMP DONE

JSELDSK:
	MOV DL,[IC]
	MOV [DISKREG],DL
	MOV AH,0EH
	PUSH DX
	INT 21H
	POP DX
	CMP DL,AL
	JGE DISKERROR
	JMP DONE
DISKERROR:
	MOV [IHL],0000H	;INVALID SELECT, SO INDICATE ERROR
	MOV BX,0000H
	JMP DONE

JSETTRK:
	JMP BIOSERROR

JSETSEC:
	JMP BIOSERROR

JSETDMA:
	MOV BX,[IBC]
	MOV [DMA],BX
	MOV AH,1AH
	INT 21H
	JMP DONE

JREAD:
	JMP BIOSERROR
JWRITE:
	JMP BIOSERROR

JLISTST:
	MOV AL,255
	OR AL,AL
	MOV [IA],AL
	JMP DONE

JSECTRAN:
	MOV BX,[IBC]
	INC BX
	MOV [IHL],BX
	JMP DONE

BIOSERROR:
	PUSH AX
	MOV DL,CR
	MOV AH,2
	INT 21H
	MOV DL,LF
	MOV AH,2
	INT 21H
	MOV DL,BELL
	MOV AH,2
	INT 21H
	POP AX
	CALL PRTBYTE

	PUSH DS
	MOV BX,CS
	MOV DS,BX
	MOV DX,BIOSERRMSG
	MOV AH,09H
	INT 21H
	POP DS

	CALL DEBUG
	JMP USERBOOT

BIOSERRMSG:
	DB ' <- Invalid BIOS call ***',BELL,CR,LF,'$'

BDOSFUNERROR:
	PUSH AX
	MOV DL,CR
	MOV AH,2
	INT 21H
	MOV DL,LF
	MOV AH,2
	INT 21H
	MOV DL,BELL
	MOV AH,2
	INT 21H
	POP AX
	MOV AL,AH
	CALL PRTBYTE

	PUSH DS
	MOV BX,CS
	MOV DS,BX
	MOV DX,FUNERRMSG
	MOV AH,09H
	INT 21H
	POP DS

	CALL DEBUG
	JMP USERBOOT

FUNERRMSG:
	DB ' <- Invalid BDOS function call ***',BELL,CR,LF,'$'



RBDOS: 
	PUSH SI
	PUSH DS

	MOV DX,[IDE]
	MOV AH,[IC]

;	CALL DEBUG

	MOV B,[DMAFLAG],00H
	MOV AL,00H
	MOV BH,0
	MOV BL,AH
	CMP BL,MAXBDOSFUN
	JNC BDOSFUNERROR
	SAL BX
	SEG CS
	JMP [BDOSFUNTABLE+BX]

NORMBDOS:
	INT 21H

BDOSDONE:
	CMP B,[DMAFLAG],00H	;FIX DMA?
	JZ NODMAMOD

	PUSH AX
	MOV DX,[DMA]
	MOV AH,1AH
	INT 21H
	POP AX

NODMAMOD:
	POP DS
	MOV [IDE],DX
	MOV [IBC],CX
	MOV [IHL],BX
	MOV [IA],AL
	OR AL,AL
	POP SI
	JMP DONE


BDOSFUNTABLE:
	DW USERBOOT	;0
	DW BDOSCONIN	;1
	DW BDOSCONOT	;2
	DW BDOSRDIN	;3
	DW BDOSPNOUT	;4
	DW BDOSLOUT	;5
	DW BDOSDIO	;6
	DW GETIO	;7
	DW PUTIO	;8
	DW BDOSPSOUT	;9
	DW BDOSRBUF	;10
	DW BDOSCONST	;11
	DW BVERSION	;12
	DW RESETSYS	;13
	DW SELDISK	;14
	DW OPENFILE	;15
	DW CLOSEFILE	;16
	DW SRCHFST	;17
	DW SRCHNXT	;18
	DW NORMBDOS	;19
	DW READSEQ	;20
	DW WRITESEQ	;21
	DW MAKEFILE	;22
	DW NORMBDOS	;23
	DW GETDLOG	;24
	DW NORMBDOS	;25
	DW SBDOSDMA	;26
	DW GETALLOC	;27
	DW NULLBDOS	;28
	DW NULLBDOS	;29
	DW NULLBDOS	;30
	DW GETPARM	;31
	DW NULLBDOS	;32
	DW RANREAD	;33
	DW RANWRITE	;34
	DW GETFSIZE	;35
	DW NORMBDOS	;36
	DW DRVRESET	;37
	DW BDOSFUNERROR	;38
	DW BDOSFUNERROR	;39
	DW RANZWRITE	;40
	DW BDOSFUNERROR	;41

MAXBDOSFUN: EQU 41


OPENFILE:
	PUSH BX
	MOV BX,DX
	MOV [BX+14],00H
	POP BX
	JMP NORMBDOS

CLOSEFILE:
	JMP NORMBDOS

GETFSIZE:
	JMP NORMBDOS
 
READSEQ:
	MOV B,[DMAFLAG],0FFH
	INT 21H
	CMP AL,03H
	JNZ READSEQX
	MOV AL,00H
READSEQX:
	JMP BDOSDONE

RANREAD:
	MOV B,[DMAFLAG],0FFH
	JMP NORMBDOS

WRITESEQ:
	MOV B,[DMAFLAG],0FFH
	PUSH BX
	MOV BX,DX
	MOV B,[BX+13],00H	;PATCH FCB
	POP BX
	JMP NORMBDOS

RANZWRITE:
	MOV B,[DMAFLAG],0FFH
	JMP NORMBDOS

RANWRITE:
	MOV B,[DMAFLAG],0FFH
	JMP NORMBDOS

MAKEFILE:
	PUSH BX
	MOV BX,DX
	MOV B,[BX+14],00H
	POP BX
	JMP NORMBDOS


DRVRESET:
	MOV AH,0DH
	JMP NORMBDOS

RESETSYS:
	MOV [DRVLOG],01H
	JMP NORMBDOS

SBDOSDMA:
	MOV [DMA],DX
	JMP NORMBDOS

NULLBDOS:
	MOV AL,00H
	MOV BX,0000H
	JMP BDOSDONE

BVERSION:
	MOV AL,22H
	MOV BX,0022H
	JMP BDOSDONE
;
SRCHFST:
	PUSH SI
	PUSH DI
	MOV SI,DX
	MOV DI,TEMPFCB
	MOV CX,48
	REP
	MOVB
	POP DI
	POP SI

	MOV DI,DX
	CMP B,[DI+0CH],'?'	;EXTENT #
	JZ SRCHFSTOK
	CMP B,[DI+0CH],00H
	JZ SRCHFSTOK
	MOV AL,0FFH
	JMP SRCHFSTEND

SRCHFSTOK:
	PUSH DX
	MOV DX,TEMPFCB
	PUSH DS
	INT 21H
	POP DS
	CALL FIXDMA
	POP DX
SRCHFSTEND:
	JMP BDOSDONE


SRCHNXT:
	PUSH DX 
	MOV DX,TEMPFCB

	MOV DI,DX
	CMP B,[DI+0CH],'?'	;EXTENT #
	JZ SRCHNXTOK
	CMP B,[DI+0CH],00H
	JZ SRCHNXTOK
	MOV AL,0FFH
	JMP SRCHNXTEND

SRCHNXTOK:
	PUSH DS
	INT 21H
	POP DS
	CALL FIXDMA
	POP DX
SRCHNXTEND:
	JMP BDOSDONE


FIXDMA:
	PUSH DX
	PUSH BX
	PUSH AX
	MOV BX,[DMA]
	MOV AH,0FH
	MOV DX,BX
	INT 21H
	MOV BX,[DMA]
	MOV B,[BX],00H		;SET USR AS 00 
	MOV B,[BX+0CH],00H	;CLEAR EXT

	MOV AX,[BX+18]		;POKE FILE SIZE INFO
	CMP AX,0000H
	JNZ FULLSIZE
	MOV AX,[BX+16]
	CMP AX,03FFFH
	JNC FULLSIZE
	ADD AX,AX
	CMP AL,00H
	JZ FIXDMADONE
	INC AH

FIXDMADONE:
	MOV [BX+15],AH

	PUSH BX
	ADD BX,10H
	MOV AL,16
FIXDMABLKLP:
	MOV B,[BX],00H	;MARK ALL GROUPS IN DMA AS ZERO
	INC BX
	DEC AL
	JNZ FIXDMABLKLP
	POP BX 

	POP AX
	POP BX
	POP DX
	RET

FULLSIZE:
	MOV AH,80H
	JMP FIXDMADONE

GETIO:
	MOV AL,[03H]
	MOV BL,AL
	MOV BH,00H
	JMP BDOSDONE
PUTIO:
	MOV AL,[IC]
	MOV BL,AL
	MOV BH,00H
	MOV [03H],AL
	JMP BDOSDONE

GETDLOG:
	MOV BX,[DRVLOG]
	MOV AL,BL
	JMP BDOSDONE

SELDISK:
	MOV AL,DL
	MOV BX,01H
DLOGLOOP:
	DEC AL
	JC DLOGDN
	ROL BX
	JMP DLOGLOOP
DLOGDN:
	OR BX,[DRVLOG]
	MOV [DRVLOG],BX
	JMP NORMBDOS

GETALLOC:
	MOV BX,ALLOC
	MOV AL,BL
	JMP BDOSDONE
GETPARM:
	MOV BX,DPARM
	MOV AL,BL
	JMP BDOSDONE

;
BDOSCONIN:
	MOV B,[CONFLAG],0FFH
	CALL BCONIN
	JMP BDOSDONE

BDOSCONOT:
	MOV B,[CONFLAG],0FFH
	CALL BCONOT
	JMP BDOSDONE

BDOSRDIN:
	MOV B,[CONFLAG],0FFH
	CALL BRDIN
	JMP BDOSDONE

BDOSPNOUT:
	MOV B,[CONFLAG],0FFH
	CALL BPUNOUT
	JMP BDOSDONE

BDOSLOUT:
	MOV B,[CONFLAG],0FFH
	CALL BLISTOUT
	JMP BDOSDONE

BDOSCONST:
	MOV B,[CONFLAG],0FFH
	CALL BCONST
	JMP BDOSDONE

BDOSDIO:
	MOV B,[CONFLAG],00H
	CMP DL,0FFH
	JZ BDOSDST
	CALL BCONOT
	JMP BDOSDONE

BDOSDST:
	CALL BCONST
	CMP AL,00H
	JNZ BDOSDOUT
	JMP BDOSDONE

BDOSDOUT:
	CALL BCONIN
	JMP BDOSDONE

BDOSPSOUT:
	MOV B,[CONFLAG],0FFH
	MOV BX,DX
BPSOUTLP:
	MOV DL,[BX]
	CMP DL,'$'
	JZ BPSOUTDN
	PUSH BX
	CALL BCONOT
	POP BX
	INC BX
	JMP BPSOUTLP
BPSOUTDN:
	JMP BDOSDONE


FLIPPRT:
	XOR B,[PRTFLAG],0FFH
	JMP INBUFA

INBUFR:
	CALL RBBCRLF
	JMP BDOSDONE

IPCRLF:
	CALL RBBCRLF
	MOV B,[BEGBUFF],00H
	JMP INBUFA

BACKSPACE:
	CALL BACKUPCHR
	JMP INBUFA

BDOSRBUF:
;	JMP NORMBDOS
INBUFF:
	MOV BX,DX
	INC BX
	MOV B,[BX],00H
	MOV AL,[SPCOUNT]
	MOV [BEGBUFF],AL
	MOV B,[DELCOUNT],00H

INBUFA:
	PUSH DX
	PUSH BX
	PUSH CX
	MOV B,[CONFLAG],00H
	CALL BCONIN
	POP CX
	POP BX
	POP DX
	AND AL,7FH
	CMP AL,0AH
	JZ INBUFR
	CMP AL,0DH
	JZ INBUFR
	CMP AL,7FH
	JZ IDELETE
	CMP AL,08H
	JZ BACKSPACE
	CMP AL,'U'-40H
	JZ INBUFU
	CMP AL,'X'-40H
	JZ INBUFX
	CMP AL,'R'-40H
	JZ RETYPE
	CMP AL,'E'-40H
	JZ IPCRLF
	CMP AL,'P'-40H
	JZ FLIPPRT
	JMP SAVEBCHR

INBUFU:
	MOV AL,'#'
	CALL RBBCONOT
	CALL RBBCRLF
	CALL SETBEGBUFF
	MOV B,[BX],00H
	MOV B,[DELCOUNT],00H
	JMP INBUFA

INBUFX:
	MOV AL,[SPCOUNT]
	CMP AL,[BEGBUFF]
	JZ INBUFXDN
	CALL ERASECHAR
	JMP INBUFX
INBUFXDN:
	MOV B,[BX],00H
	JMP INBUFA

RETYPE:
	MOV B,[DELCOUNT],00H
	MOV AL,'#'
	CALL RBBCONOT
	CALL RBBCRLF
	CALL SETBEGBUFF
	CMP B,[BX],00H
	JZ RETYPEDN
	CALL TYPEITBACK
RETYPEDN:
	JMP INBUFA

IDELETE:
	CMP B,[BX],00H
	JZ NODELETE
	CALL RDBUFCHR
	PUSH AX
	CALL RBBCONOT
	POP AX
	DEC B,[BX]

	CMP AL,'I'-40H
	JZ TABBACKUP
	CMP AL,' '
	JNC NOTCTRLDEL
	ADD B,[DELCOUNT],2
NOTCTRLDEL:
	ADD B,[DELCOUNT],2
	JMP INBUFA

TABBACKUP:
	MOV AL,[SPCOUNT]
	AND AL,07H
	JNZ NOTFULLTAB
	MOV AL,08H
NOTFULLTAB:
	ADD [DELCOUNT],AL 
	
NODELETE:
	JMP INBUFA


BACKUPCHR:
	CMP B,[BX],00H
	JZ NOBACKUP
	CMP B,[SPCOUNT],00H
	JZ NOBACKUP

DELERALOOP:
	CMP B,[DELCOUNT],00H
	JZ DELBACKDN
	CALL ERASECHAR
	DEC B,[DELCOUNT]
	JNZ DELERALOOP

DELBACKDN:
	CALL ERASECHAR
	DEC B,[BX]
NOBACKUP:
	RET

ERASECHAR:
	MOV AL,08H
	CALL RBBCONOT
	MOV AL,' '
	CALL RBBCONOT
	MOV AL,08H
	CALL RBBCONOT
	RET

RDBUFCHR:
	PUSH CX
	PUSH BX
	MOV CH,00H
	MOV CL,[BX]
	ADD BX,CX
	MOV AL,[BX]
	POP BX
	POP CX
	RET

TYPEITBACK:
	PUSH CX
	PUSH BX
	MOV CL,[BX]
CTLRLP:
	INC BX
	MOV AL,[BX]
	CALL RBBCONOT
	DEC CL
	JNZ CTLRLP
	POP BX
	POP CX
	RET

FORWARDTAB:
	PUSH CX
	MOV CL,[SPCOUNT]
	AND CL,07H
FWDTABDN:
	MOV AL,08H
	SUB AL,CL
	DEC AL
	POP CX
	ADD [DELCOUNT],AL
	MOV AL,'I'-40H
	JMP SAVCHRCNT

SAVEBCHR:
	CMP AL,'I'-40H
	JZ FORWARDTAB
	CMP AL,'C'-40H
	JNZ SAVCHRCNT
	CMP B,[BX],00H
	JNZ SAVCHRCNT
	JMP USERBOOT

SAVCHRCNT:
	INC B,[BX]
	PUSH CX
	PUSH BX
	MOV CH,00H
	MOV CL,[BX]
	ADD BX,CX
	MOV [BX],AL
	POP BX
	CALL RBBCONOT
	MOV CL,[BX]
	CMP CL,[BX-1]
	POP CX
	JNC IALERT
	JMP INBUFA

IALERT:
	JMP INBUFR	;OVERFLOW EXIT

RBBCONOT:
	PUSH DX
	PUSH BX
	PUSH CX
	PUSH AX
	CMP AL,0DH
	JZ DORBCONOT
	CMP AL,0AH
	JZ DORBCONOT 
	CMP AL,'I'-40H
	JZ DORBCONOT
	CMP AL,'H'-40H
	JZ DORBCONOT
	CMP AL,' '
	JNC DORBCONOT
	PUSH AX
	MOV AL,'^'
	CALL RBBCONOT
	POP AX
	OR AL,40H
DORBCONOT:
	MOV B,[CONFLAG],0FFH
	MOV DL,AL
	CALL BCONOT
	POP AX
	POP CX
	POP BX
	POP DX
	RET

RBBCRLF:
	PUSH AX
	MOV AL,0DH
	CALL RBBCONOT
	MOV AL,0AH
	CALL RBBCONOT
	POP AX
	RET

SETBEGBUFF:
	MOV AL,[SPCOUNT]
	CMP AL,[BEGBUFF]
	JZ BEGBUFFDN
	MOV AL,' '
	CALL RBBCONOT
	JMP SETBEGBUFF
BEGBUFFDN:
	RET






INITMORE:
	MOV SI,2
	MOV BX,[SI]
;
; SETUP TEMP FCB
	PUSH BX
	MOV SI,005CH
	MOV DI,FCB
	MOV CX,16
	REP
	MOVB
	POP BX
;
; SET UP SEGMENT REGISTER
	MOV DX,RAMSEGMENT
	MOV CX,DS
	ADD DX,CX
	MOV ES,DX

	MOV AX,DX
	ADD AX,4096
	CMP AX,BX
	JC INITSZOK

	SUB AX,BX
	PUSH AX
	MOV AL,CR
	CALL TYPEITOUT
	MOV AL,LF
	CALL TYPEITOUT
	MOV AL,BELL
	CALL TYPEITOUT
	MOV AL,'['
	CALL TYPEITOUT
	MOV AL,'-'
	CALL TYPEITOUT
	POP AX
	PUSH AX
	MOV AL,AH
	CALL PRTBYTE
	POP AX
	CALL PRTBYTE
	MOV AL,'0'
	CALL TYPEITOUT

	MOV BX,CS
	MOV DS,BX
	MOV DX,NOMEMMSG
	MOV AH,09H
	INT 21H
	JMP USERBOOT	;RE BOOT

NOMEMMSG:
	DB '] *** Insufficient user memory available to run program ***'
	DB 7,CR,LF,'$'


;
; SETUP JUMP TABLES OF CPM
;
INITSZOK:
	MOV SI,BOOT
	MOV DI,0000H
	MOV CX,100H
	REP
	MOVB
;
	MOV SI,REALBDOS
	MOV DI,0EC06H
	MOV CX,4
	REP
	MOVB
;
	MOV SI,CPMJMP
	MOV DI,0FA00H
	MOV CX,80H
	REP
	MOVB
;
	MOV SI,CBOOT
	MOV DI,0FB00H
	MOV CX,128
	REP
	MOVB

;
; SETUP FCB TO READ IN COM FILE



	CMP B,[FCB+9],20H
	JNE WHOLEFCB

	MOV B,[FCB+9],'C'
	MOV B,[FCB+10],'P'
	MOV B,[FCB+11],'M'

WHOLEFCB:
	MOV SI,FCB
	MOV DI,0FE00H
	MOV CX,36
	REP
	MOVB
;
	MOV DS,DX
;CREATE DEFDMA COMMAND LINE
;
	MOV BX,81H
SPDINITLP:
	SEG CS
	MOV AL,[80H]
	CMP AL,00H
	JZ DEFEMPTY
	SEG CS
	MOV AL,[BX]
	CMP AL,20H
	JNZ SPSEARCH	
	INC BX
	SEG CS
	DEC B,[80H]
	JZ DEFEMPTY
	JMP SPDINITLP

SPSEARCH:
	SEG CS
	MOV AL,[BX]
	CMP AL,20H
	JZ FOUNDSP
	INC BX
	SEG CS
	DEC B,[80H]
	JZ DEFEMPTY
	JMP SPSEARCH

FOUNDSP:
	SEG CS
	MOV AL,[80H]
	MOV [80H],AL
	MOV DI,81H
FILEMOVLP:
	SEG CS
	MOV AL,[BX]
	MOV [DI],AL
	INC BX
	INC DI
	SEG CS
	DEC B,[80H]
 	JNZ FILEMOVLP
	MOV B,[DI],00H
	JMP FILEMOVDN
DEFEMPTY:
	MOV W,[80H],00H

FILEMOVDN:
	MOV B,[BYTERDYFLG],00H	;INIT FLAGS
	MOV B,[COMBRDYFLG],00H
	MOV B,[PRTFLAG],00H
	MOV B,[SPCOUNT],00H
	MOV B,[CURFLAG],00H
	MOV B,[EQFLAG],00H
	MOV B,[ROWFLAG],00H

	MOV W,[DRVLOG],01H	;START WITH DRIVE A ALWAYS LOGGED IN
	MOV AH,19H
	INT 21H			;ALSO LOG IN DEFAULT DRIVE
	INC AL
	MOV BX,1
DRVINTLOOP:
	DEC AL
	JZ DRVINTALLDN
	CLC
	RCL BX
	JMP DRVINTLOOP

DRVINTALLDN:
	OR [DRVLOG],BX

	MOV BX,ALLOC
	MOV CL,00H		;INIT DRV ALLOC TABLE
ALLOCINT:
	MOV B,[BX],00H
	INC BX
	DEC CL
	JNZ ALLOCINT

	MOV AH,30H
	INT 21H
	CMP AL,0
	JNZ SETDP2

	MOV W,[DPARM],32	;SPT	;FOR VERSION 1 MSDOS
	MOV B,[DPARM+2],3	;BSH
	MOV B,[DPARM+3],7	;BLM
	MOV B,[DPARM+4],0	;EXM
	MOV W,[DPARM+5],160	;DSM
	MOV W,[DPARM+7],63	;DRM
	MOV B,[DPARM+9],0C0H	;AL0
	MOV B,[DPARM+10],00H	;AL1
	MOV W,[DPARM+11],16	;CKS
	MOV W,[DPARM+13],2	;OFF
	JMP INITCURPOS

SETDP2:
	MOV W,[DPARM],36	;SPT	;FOR VERSION 2 MSDOS
	MOV B,[DPARM+2],3	;BSH
	MOV B,[DPARM+3],7	;BLM
	MOV B,[DPARM+4],0	;EXM
	MOV W,[DPARM+5],359	;DSM
	MOV W,[DPARM+7],63	;DRM
	MOV B,[DPARM+9],0C0H	;AL0
	MOV B,[DPARM+10],00H	;AL1
	MOV W,[DPARM+11],16	;CKS
	MOV W,[DPARM+13],2	;OFF


INITCURPOS:
	MOV AX,[DPARM+9]	;GET DIR ALLOC
	MOV W,[ALLOC],AX	;SETUP ALLOC TABLE 
	MOV AH,3		;INIT CURSOR TO SAFE POSITION
	MOV AL,0
	MOV BX,0
	INT 10H
	CMP DH,24
	JC SROWOK
	PUSH DX
	MOV AL,1
	MOV AH,6
	MOV CX,0
	MOV DH,23
	MOV DL,79
	SEG CS
	MOV BH,[ATRIB]
	INT 10H
	POP DX
	MOV DH,23
	MOV AH,2
	MOV AL,0
	MOV BX,0
	INT 10H
SROWOK:

;
     IF NOTREENTER
;
; OPEN THE COM FILE
;
	MOV BX,0FE01H
	MOV AL,[BX]
	CMP AL,' '
	JNZ GOTAFILE

	MOV AX,CS
	MOV DS,AX
	MOV DX,CPMMSG	;NO FILENAME, SO PRINT HEADED
	MOV AH,9
	INT 21H
	JMP USERBOOT

GOTAFILE:
	MOV AH,0FH	;OPEN FILE FUNCTION
	MOV DX,0FE00H	;FCB IN HIGH MEMORY
	INT 21H
	OR AL,AL
	JNZ NOFILEFND
	JMP OPENOK
;			FILE DOES NOT EXIST MESSAGE
NOFILEFND:
	MOV AL,CR
	CALL TYPEITOUT
	MOV AL,LF
	CALL TYPEITOUT
	MOV AL,BELL
	CALL TYPEITOUT

	MOV DX,0FE00H
	CALL FPRINT	;PRINT THE FILE NAME

	MOV BX,CS
	MOV DS,BX
	MOV DX,NOFILMSG
	MOV AH,09H
	INT 21H
	JMP USERBOOT		;RE BOOT

NOFILMSG:
	DB ' <- That program name does not exist ***',CR,LF,'$'

FILETOOBIG:
	MOV AL,CR
	CALL TYPEITOUT
	MOV AL,LF
	CALL TYPEITOUT
	MOV AL,BELL
	CALL TYPEITOUT

	MOV DX,0FE00H
	CALL FPRINT

	MOV BX,CS
	MOV DS,BX
	MOV DX,BIGFILMSG
	MOV AH,09H
	INT 21H
	JMP USERBOOT		;RE BOOT

BIGFILMSG:
	DB ' <- That program is too big to run ***',CR,LF,'$' 


OPENOK:
;
;
; READ COM FILE INTO MEMORY 
;
READFILE:
	MOV BX,[0FE00H+18]
	OR BX,BX
	JNZ FILETOOBIG

	MOV BX,[0FE00H+16]	;GET FILE SIZE TO READ
	CMP BX,0EC00H
	JNC FILETOOBIG
	MOV [0FE00H+14],BX

	MOV DX,100H
	MOV [DMA],DX
; READ A RECORD
READLOOP:
	MOV DX,[DMA]
	MOV AH,1AH	;SET DMA
	INT 21H
;
	MOV DX,0FE00H
	MOV AH,14H
	INT 21H		;READ PRG IN
;

     ENDIF


; CREATE FIRST AND SECOND FCB IN PROGRAM AREA
;
; CLEAR FCB AREA
;
	MOV BX,5CH	;TARGET AREA IN DS
	MOV CX,24H	;COUNT 80H-5CH
CLRLOOP:
	MOV B,[BX],00H	;CLEAR A BYTE
	INC BX
	DEC CX
	JNZ CLRLOOP
;
;		SET UP FIRST FILE NAME FOR EMULATOR
	MOV CX,16
	MOV BX,6CH
	MOV DI,5CH
MOVFILNAM:
	SEG CS
	MOV AL,[BX]
	MOV [DI],AL
	INC BX
	INC DI
	DEC CX
	JNZ MOVFILNAM

;NOW GEN THE SECOND FILENAME IN FCB

	MOV BX,81H
	MOV CL,[80H]
	MOV AL,[BX]
	CMP AL,20H
	JNZ SKIPFILE
	INC BX
	DEC CL

SKIPFILE:
	OR CL,CL
	JZ EMPTY
	MOV AL,[BX]
	CMP AL,20H
	JE SKIPSPACE
	DEC CL
	INC BX
	JMP SKIPFILE
;
SKIPSPACE:
	INC BX
	DEC CL
	JZ EMPTY
	CMP B,[BX],20H
	JZ SKIPSPACE

;BX NOW POINTS TO BEG OF SECOND FILENAME,
; SO PARSE IT WITH MSDOS CALL 
;
FINDFILE:

	MOV DI,6CH
	MOV SI,DS
	MOV ES,SI
	MOV SI,BX
	MOV AL,00H
	MOV AH,29H
	INT 21H

	JMP FILEDONE

;GENERATE A BLANK FCB HERE IF NO NAME WAS GIVEN

EMPTY:
	MOV B,[6CH],00H

	MOV CL,11
	MOV BX,6DH
EMPTYSP:
	MOV B,[BX],20H
	INC BX
	DEC CL
	JNZ EMPTYSP
	JMP FILEDONE

;THE TRAILING NULLS WERE LOADED DURING THE FCB INIT



;THIS PRINTS A FILENAME

FPRINT:
	PUSH BX
	PUSH DX
	PUSH CX
	MOV BX,DX
	MOV AL,[BX]
	INC BX
	CMP AL,00H
	JNZ FPRINTOK
	MOV AH,19H
	INT 21H
	INC AL
FPRINTOK:
	OR AL,40H
	CALL TYPEITOUT
	MOV AL,3AH
	CALL TYPEITOUT
	MOV CX,9
FPRINT1LP:
	MOV AL,[BX]
	INC BX
	DEC CX
	JZ FPRINT3
	CMP AL,' '
	JZ FPRINT2
	CALL TYPEITOUT
	JMP FPRINT1LP
FPRINT2:
	INC BX
	DEC CX
	JNZ FPRINT2
FPRINT3:
	DEC BX
	MOV AL,'.'
	CALL TYPEITOUT
	MOV CX,4
FPRINT3LP:
	MOV AL,[BX]
	INC BX
	DEC CX
	JZ FPRINT4
	CMP AL,' '
	JZ FPRINT4
	CALL TYPEITOUT
	JMP FPRINT3LP
FPRINT4:
	POP DX
	POP BX
	POP CX
	RET


TYPEITOUT:
	PUSH AX
	PUSH CX
	PUSH DX
	MOV DL,AL
	MOV AH,2
	INT 21H
	POP DX
	POP CX
	POP AX
	RET

;WE AFE ALL READY, SO LET'S GO OK?

FILEDONE:

;
; SET DMA TO CP/M DEFAULT

	MOV DX,80H
	MOV [DMA],DX
	MOV AH,1AH	;SET DMA
	INT 21H

	MOV [ISP],CPMSTACK	;INIT CPM STACK
	MOV [CPMSTACK],0FA00H	;EXIT TO COLD BOOT 

;
; TURN OFF TRACE
	MOV B,[BUGFLG],00H

SETPC:
	MOV SI,100H

;
; CLEAR COMMAND LINE
;
; DO AN INSTRUCTION ROUTINE
; MAIN SUBROUTINE TO FETCH THE FIRST BYTE OF AN INSTRUCTION
; AND CHOSE A ROUTINE TO PERFORM THE REQUIRED FUNCTION.
;
; THE ROUTINE JUMPED TO SHOULD JUMP BACK TO DONE, WHEN FINISHED
; TO PERFORM THE NEXT INSTRUCTION.
;
DONE:
;
; RETURN HERE FROM INSTRUCTION PROCESSING
;
DOANINST:
	LAHF

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]



;
;
; TABLE OF JUMP ADDRESSES FOR EACH POSSIBLE INSTRUCTION
; Z80 CODE IS NOT IMPLEMENTED.
;
;
;
;
JMPTAB:	DW NOP80		;00H
	DW LXIB
	DW STAXB
	DW INXB
	DW INRB
	DW DCRB
	DW MVIB
	DW RLC80
	DW Z8008		;08H
	DW DADB
	DW LDAXB
	DW DCXB
	DW INRC
	DW DCRC
	DW MVIC
	DW RRC80
	DW Z8010		;10H
	DW LXID
	DW STAXD
	DW INXD
	DW INRD
	DW DCRD
	DW MVID
	DW RAL80
	DW Z8018		;18H
	DW DADD
	DW LDAXD
	DW DCXD
	DW INRE
	DW DCRE
	DW MVIE
	DW RAR80
	DW Z8020		;20H
	DW LXIH
	DW SHLD
	DW INXH
	DW INRH
	DW DCRH
	DW MVIH
	DW DAA80
	DW Z8028		;28H
	DW DADH
	DW LHLD
	DW DCXH
	DW INRL
	DW DCRL
	DW MVIL
	DW CMA80
	DW Z8030		;30H
	DW LXISP
	DW STA
	DW INXSP
	DW INRM
	DW DCRM
	DW MVIM
	DW STC80
	DW Z8038		;38H
	DW DADSP
	DW LDA
	DW DCXSP
	DW INRA
	DW DCRA
	DW MVIA
	DW CMC80
	DW MOVBB		;40H
	DW MOVBC
	DW MOVBD
	DW MOVBE
	DW MOVBH
	DW MOVBL
	DW MOVBM
	DW MOVBA
	DW MOVCB	;48H
	DW MOVCC
	DW MOVCD
	DW MOVCE
	DW MOVCH
	DW MOVCL
	DW MOVCM
	DW MOVCA
	DW MOVDB		;50H
	DW MOVDC
	DW MOVDD
	DW MOVDE
	DW MOVDH
	DW MOVDL
	DW MOVDM
	DW MOVDA
	DW MOVEB	;58H
	DW MOVEC
	DW MOVED
	DW MOVEE
	DW MOVEH
	DW MOVEL
	DW MOVEM
	DW MOVEA
	DW MOVHB	;60H
	DW MOVHC
	DW MOVHD
	DW MOVHE
	DW MOVHH
	DW MOVHL
	DW MOVHM
	DW MOVHA
	DW MOVLB
	DW MOVLC
	DW MOVLD
	DW MOVLE
	DW MOVLH
	DW MOVLL
	DW MOVLM
	DW MOVLA
	DW MOVMB	;70H
	DW MOVMC
	DW MOVMD
	DW MOVME
	DW MOVMH
	DW MOVML
	DW HLT80		;76H
	DW MOVMA
	DW MOVAB
	DW MOVAC
	DW MOVAD
	DW MOVAE
	DW MOVAH
	DW MOVAL
	DW MOVAM
	DW MOVAA
	DW ADDB		;80H
	DW ADDC
	DW ADDD
	DW ADDE
	DW ADDH
	DW ADDL
	DW ADDM
	DW ADDA
	DW ADCB
	DW ADCC
	DW ADCD
	DW ADCE
	DW ADCH
	DW ADCL
	DW ADCM
	DW ADCA
	DW SUBB		;90H
	DW SUBC
	DW SUBD
	DW SUBE
	DW SUBH
	DW SUBL
	DW SUBM
	DW SUBA
	DW SBBB
	DW SBBC
	DW SBBD
	DW SBBE
	DW SBBH
	DW SBBL
	DW SBBM
	DW SBBA
	DW ANAB		;A0H
	DW ANAC
	DW ANAD
	DW ANAE
	DW ANAH
	DW ANAL
	DW ANAM
	DW ANAA
	DW XRAB
	DW XRAC
	DW XRAD
	DW XRAE
	DW XRAH
	DW XRAL
	DW XRAM
	DW XRAA
	DW ORAB		;B0H
	DW ORAC
	DW ORAD
	DW ORAE
	DW ORAH
	DW ORAL
	DW ORAM
	DW ORAA
	DW CMPB
	DW CMPC
	DW CMPD
	DW CMPE
	DW CMPH
	DW CMPL
	DW CMPM
	DW CMPA
	DW RNZ80
	DW POPB		;C1H
	DW JNZ80
	DW JMP80
	DW CNZ80
	DW PUSHB	;C5H
	DW ADI80
	DW RST0		;C7H
	DW RZ80
	DW XRET
	DW JZ80
	DW Z80CB		;CBH
	DW CZ80
	DW CALL80
	DW ACI80
	DW RST1		;CFH
	DW RNC80
	DW POPD		;D1H
	DW JNC80
	DW OUT80
	DW CNC80
	DW PUSHD	;D5H
	DW SUI80
	DW RST2		;D7H
	DW RC80
	DW Z80D9		;D9H
	DW JC80
	DW IN80
	DW CC80
	DW Z80DD		;DDH
	DW SBI80
	DW RST3		;DFH
	DW RPO80
	DW POPH		;E1H
	DW JPO80
	DW XTHL
	DW CPO80
	DW PUSHH	;E5H
	DW ANI80
	DW RST4		;E7H
	DW RPE80
	DW PCHL
	DW JPE80
	DW XCHG80
	DW CPE80
	DW MACROED	;EDH
	DW XRI80
	DW RST5		;EFH
	DW RP80
	DW POPPSW
	DW JP80
	DW DI80
	DW CP80
	DW PUSHPSW
	DW ORI80
	DW RST6		;F7H
	DW RM80
	DW SPHL
	DW JM80
	DW EI80
	DW CM80
	DW Z80FD		;FDH
	DW CPI80
	DW RST7		;FFH
;
; END OF CODE TABLE
;
;
;
; PERFORM EACH INSTRUCTION
;

;

MOVBB:
	MOV AL,[IB]
	MOV [IB],AL
	INC SI

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
MOVBC:
	MOV AL,[IC]
	MOV [IB],AL
	INC SI

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
MOVBD:
	MOV AL,[ID]
	MOV [IB],AL
	INC SI

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
MOVBE:
	MOV AL,[IE]
	MOV [IB],AL
	INC SI

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
MOVBH:
	MOV AL,[IH]
	MOV [IB],AL
	INC SI

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
MOVBL:
	MOV AL,[IL]
	MOV [IB],AL
	INC SI

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
MOVBM:
	MOV BX,[IHL]
	MOV AL,[BX]
	MOV [IB],AL
	INC SI

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
MOVBA:
	MOV AL,[IA]
	MOV [IB],AL
	INC SI

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
MOVCB:
	MOV AL,[IB]
	MOV [IC],AL
	INC SI

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
MOVCC:
	MOV AL,[IC]
	MOV [IC],AL
	INC SI

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
MOVCD:
	MOV AL,[ID]
	MOV [IC],AL
	INC SI

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
MOVCE:
	MOV AL,[IE]
	MOV [IC],AL
	INC SI

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
MOVCH:
	MOV AL,[IH]
	MOV [IC],AL
	INC SI

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
MOVCL:
	MOV AL,[IL]
	MOV [IC],AL
	INC SI

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
MOVCM:
	MOV BX,[IHL]
	MOV AL,[BX]
	MOV [IC],AL
	INC SI

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
MOVCA:
	MOV AL,[IA]
	MOV [IC],AL
	INC SI
	SAHF
	LAHF

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
MOVDB:
	MOV AL,[IB]
	MOV [ID],AL
	INC SI

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
MOVDC:
	MOV AL,[IC]
	MOV [ID],AL
	INC SI

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
MOVDD:
	MOV AL,[ID]
	MOV [ID],AL
	INC SI

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
MOVDE:
	MOV AL,[IE]
	MOV [ID],AL
	INC SI

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
MOVDH:
	MOV AL,[IH]
	MOV [ID],AL
	INC SI

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
MOVDL:
	MOV AL,[IL]
	MOV [ID],AL
	INC SI

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
MOVDM:
	MOV BX,[IHL]
	MOV AL,[BX]
	MOV [ID],AL
	INC SI

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
MOVDA:
	MOV AL,[IA]
	MOV [ID],AL
	INC SI

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
MOVEB:
	MOV AL,[IB]
	MOV [IE],AL
	INC SI

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
MOVEC:
	MOV AL,[IC]
	MOV [IE],AL
	INC SI

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
MOVED:
	MOV AL,[ID]
	MOV [IE],AL
	INC SI

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
MOVEE:
	MOV AL,[IE]
	MOV [IE],AL
	INC SI

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
MOVEH:
	MOV AL,[IH]
	MOV [IE],AL
	INC SI

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
MOVEL:
	MOV AL,[IL]
	MOV [IE],AL
	INC SI

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
MOVEM:
	MOV BX,[IHL]
	MOV AL,[BX]
	MOV [IE],AL
	INC SI

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
MOVEA:
	MOV AL,[IA]
	MOV [IE],AL
	INC SI

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
MOVHB:
	MOV AL,[IB]
	MOV [IH],AL
	INC SI

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
MOVHC:
	MOV AL,[IC]
	MOV [IH],AL
	INC SI

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
MOVHD:
	MOV AL,[ID]
	MOV [IH],AL
	INC SI

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
MOVHE:
	MOV AL,[IE]
	MOV [IH],AL
	INC SI

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
MOVHH:
	MOV AL,[IH]
	MOV [IH],AL
	INC SI

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
MOVHL:
	MOV AL,[IL]
	MOV [IH],AL
	INC SI

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
MOVHM:
	MOV BX,[IHL]
	MOV AL,[BX]
	MOV [IH],AL
	INC SI

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
MOVHA:
	MOV AL,[IA]
	MOV [IH],AL
	INC SI

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
MOVLB:
	MOV AL,[IB]
	MOV [IL],AL
	INC SI

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
MOVLC:
	MOV AL,[IC]
	MOV [IL],AL
	INC SI

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
MOVLD:
	MOV AL,[ID]
	MOV [IL],AL
	INC SI

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
MOVLE:
	MOV AL,[IE]
	MOV [IL],AL
	INC SI

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
MOVLH:
	MOV AL,[IH]
	MOV [IL],AL
	INC SI

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
MOVLL:
	MOV AL,[IL]
	MOV [IL],AL
	INC SI

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
MOVLM:
	MOV BX,[IHL]
	MOV AL,[BX]
	MOV [IL],AL
	INC SI

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
MOVLA:
	MOV AL,[IA]
	MOV [IL],AL
	INC SI

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
MOVMB:
	MOV AL,[IB]
	MOV BX,[IHL]
	MOV [BX],AL
	INC SI

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
MOVMC:
	MOV AL,[IC]
	MOV BX,[IHL]
	MOV [BX],AL
	INC SI

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
MOVMD:
	MOV AL,[ID]
	MOV BX,[IHL]
	MOV [BX],AL
	INC SI

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
MOVME:
	MOV AL,[IE]
	MOV BX,[IHL]
	MOV [BX],AL
	INC SI

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
MOVMH:
	MOV AL,[IH]
	MOV BX,[IHL]
	MOV [BX],AL
	INC SI

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
MOVML:
	MOV AL,[IL]
	MOV BX,[IHL]
	MOV [BX],AL
	INC SI

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
; NOTE MOVMM IS HLT

;--------------------------------
MOVMA:
	MOV AL,[IA]
	MOV BX,[IHL]
	MOV [BX],AL
	INC SI

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]



;--------------------------------
MOVAB:
	MOV AL,[IB]
	MOV [IA],AL
	INC SI

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
MOVAC:
	MOV AL,[IC]
	MOV [IA],AL
	INC SI

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
MOVAD:
	MOV AL,[ID]
	MOV [IA],AL
	INC SI

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
MOVAE:
	MOV AL,[IE]
	MOV [IA],AL
	INC SI

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
MOVAH:
	MOV AL,[IH]
	MOV [IA],AL
	INC SI

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
MOVAL:
	MOV AL,[IL]
	MOV [IA],AL
	INC SI

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
MOVAM:
	MOV BX,[IHL]
	MOV AL,[BX]
	MOV [IA],AL
	INC SI

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
MOVAA:
	MOV AL,[IA]
	MOV [IA],AL
	INC SI

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]




;--------------------------------
MVIB:
	MOV AL,[SI+1]
	MOV [IB],AL
	ADD SI,2

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
MVIC:
	MOV AL,[SI+1]
	MOV [IC],AL
	ADD SI,2

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
MVID:
	MOV AL,[SI+1]
	MOV [ID],AL
	ADD SI,2

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
MVIE:
	MOV AL,[SI+1]
	MOV [IE],AL
	ADD SI,2

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
MVIH:
	MOV AL,[SI+1]
	MOV [IH],AL
	ADD SI,2

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
MVIL:
	MOV AL,[SI+1]
	MOV [IL],AL
	ADD SI,2

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


;--------------------------------
MVIM:
	MOV AL,[SI+1]
	MOV BX,[IHL]
	MOV [BX],AL
	ADD SI,2

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


;--------------------------------
MVIA:
	MOV AL,[SI+1]
	MOV [IA],AL
	ADD SI,2

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


;--------------------------------
LXIB:
	MOV DX,[SI+1]
	MOV [IBC],DX
	ADD SI,3

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


;--------------------------------
LXID:
	MOV DX,[SI+1]
	MOV [IDE],DX
	ADD SI,3

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


;--------------------------------
LXIH:
	MOV DX,[SI+1]
	MOV [IHL],DX
	ADD SI,3

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
LXISP:
	MOV DX,[SI+1]
	MOV [ISP],DX
	ADD SI,3

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


;--------------------------------
LDA:
	MOV BX,[SI+1]
	MOV DL,[BX]
	MOV [IA],DL
	ADD SI,3

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


;--------------------------------
STA:
	MOV BX,[SI+1]
	MOV DL,[IA]
	MOV [BX],DL
	ADD SI,3

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


;--------------------------------
LHLD:
	MOV BX,[SI+1]
	MOV DX,[BX]
	MOV [IHL],DX
	ADD SI,3

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
SHLD:
	MOV BX,[SI+1]
	MOV DX,[IHL]
	MOV [BX],DX
	ADD SI,3

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
LDAXB:
	MOV BX,[IBC]
	MOV DL,[BX]
	MOV [IA],DL
	INC SI

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
LDAXD:
	MOV BX,[IDE]
	MOV DL,[BX]
	MOV [IA],DL
	INC SI

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
STAXB:
	MOV BX,[IBC]
	MOV CL,[IA]
	MOV [BX],CL
	INC SI

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
STAXD:
	MOV BX,[IDE]
	MOV CL,[IA]
	MOV [BX],CL
	INC SI

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
XCHG80:
	MOV DX,[IDE]
	MOV CX,[IHL]
	MOV [IDE],CX
	MOV [IHL],DX
	INC SI

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
ADDB:
	INC SI
	MOV DL,[IB]
	SAHF
	ADD [IA],DL
	LAHF

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
ADDC:
	INC SI
	MOV DL,[IC]
	SAHF
	ADD [IA],DL
	LAHF

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
ADDD:
	INC SI
	MOV DL,[ID]
	SAHF
	ADD [IA],DL
	LAHF

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
ADDE:
	INC SI
	MOV DL,[IE]
	SAHF
	ADD [IA],DL
	LAHF

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
ADDH:
	INC SI
	MOV DL,[IH]
	SAHF
	ADD [IA],DL
	LAHF

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
ADDL:
	INC SI
	MOV DL,[IL]
	SAHF
	ADD [IA],DL
	LAHF

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
ADDM:
	INC SI
	MOV BX,[IHL]
	MOV DL,[BX]
	SAHF
	ADD [IA],DL
	LAHF

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
ADDA:
	INC SI
	MOV DL,[IA]
	SAHF
	ADD [IA],DL
	LAHF

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
ADI80:
	MOV CL,[SI+1]
	SAHF
	ADD [IA],CL
	LAHF
	ADD SI,2
	SAHF
	LAHF

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
ADCB:
	INC SI
	MOV DL,[IB]
	SAHF
	ADC [IA],DL
	LAHF

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
ADCC:
	INC SI
	MOV DL,[IC]
	SAHF
	ADC [IA],DL
	LAHF

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
ADCD:
	INC SI
	MOV DL,[ID]
	SAHF
	ADC [IA],DL
	LAHF

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
ADCE:
	INC SI
	MOV DL,[IE]
	SAHF
	ADC [IA],DL
	LAHF

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
ADCH:
	INC SI
	MOV DL,[IH]
	SAHF
	ADC [IA],DL
	LAHF

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
ADCL:
	INC SI
	MOV DL,[IL]
	SAHF
	ADC [IA],DL
	LAHF

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
ADCM:
	INC SI
	MOV BX,[IHL]
	MOV DL,[BX]
	SAHF
	ADC [IA],DL
	LAHF

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
ADCA:
	INC SI
	MOV DL,[IA]
	SAHF
	ADC [IA],DL
	LAHF

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------

ACI80:
	MOV CL,[SI+1]
	SAHF
	ADC [IA],CL
	LAHF
	ADD SI,2

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------

SUBB:
	INC SI
	MOV DL,[IB]
	SAHF
	SUB [IA],DL
	LAHF

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------

SUBC:
	INC SI
	MOV DL,[IC]
	SAHF
	SUB [IA],DL
	LAHF

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------

SUBD:
	INC SI
	MOV DL,[ID]
	SAHF
	SUB [IA],DL
	LAHF

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------

SUBE:
	INC SI
	MOV DL,[IE]
	SAHF
	SUB [IA],DL
	LAHF

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------

SUBH:
	INC SI
	MOV DL,[IH]
	SAHF
	SUB [IA],DL
	LAHF

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------

SUBL:
	INC SI
	MOV DL,[IL]
	SAHF
	SUB [IA],DL
	LAHF

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------

SUBM:
	INC SI
	MOV BX,[IHL]
	MOV DL,[BX]
	SAHF
	SUB [IA],DL
	LAHF

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------

SUBA:
	INC SI
	MOV DL,[IA]
	SAHF
	SUB [IA],DL
	LAHF

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------

SUI80:
	MOV CL,[SI+1]
	SAHF
	SUB [IA],CL
	LAHF
	ADD SI,2

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------

SBBB:
	INC SI
	MOV DL,[IB]
	SAHF
	SBB [IA],DL
	LAHF

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------

SBBC:
	INC SI
	MOV DL,[IC]
	SAHF
	SBB [IA],DL
	LAHF

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------

SBBD:
	INC SI
	MOV DL,[ID]
	SAHF
	SBB [IA],DL
	LAHF

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------

SBBE:
	INC SI
	MOV DL,[IE]
	SAHF
	SBB [IA],DL
	LAHF

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------

SBBH:
	INC SI
	MOV DL,[IH]
	SAHF
	SBB [IA],DL
	LAHF

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------

SBBL:
	INC SI
	MOV DL,[IL]
	SAHF
	SBB [IA],DL
	LAHF

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------

SBBM:
	INC SI
	MOV BX,[IHL]
	MOV DL,[BX]
	SAHF
	SBB [IA],DL
	LAHF

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------

SBBA:
	INC SI
	MOV DL,[IA]
	SAHF
	SBB [IA],DL
	LAHF

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------

INRA:
	INC SI
	SAHF
	INC B,[IA]
	LAHF

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
INRB:
	INC SI
	SAHF
	INC B,[IB]
	LAHF

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
INRC:
	INC SI
	SAHF
	INC B,[IC]
	LAHF

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
INRD:
	INC SI
	SAHF
	INC B,[ID]
	LAHF

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
INRE:
	INC SI
	SAHF
	INC B,[IE]
	LAHF

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
INRH:
	INC SI
	SAHF
	INC B,[IH]
	LAHF

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
INRL:
	INC SI
	SAHF
	INC B,[IL]
	LAHF

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
INRM:
	INC SI
	MOV BX,[IHL]
	SAHF
	INC B,[BX]
	LAHF

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
DCRA:
	INC SI
	SAHF
	DEC B,[IA]
	LAHF

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
DCRB:
	INC SI
	SAHF
	DEC B,[IB]
	LAHF

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
DCRC:
	INC SI
	SAHF
	DEC B,[IC]
	LAHF

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------

DCRD:
	INC SI
	SAHF
	DEC B,[ID]
	LAHF

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
DCRE:
	INC SI
	SAHF
	DEC B,[IE]
	LAHF

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
DCRH:
	INC SI
	SAHF
	DEC B,[IH]
	LAHF

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
DCRL:
	INC SI
	SAHF
	DEC B,[IL]
	LAHF

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
DCRM:
	INC SI
	MOV BX,[IHL]
	SAHF
	DEC B,[BX]
	LAHF

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
INXSP:
	INC SI
	INC [ISP]

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
INXB:
	INC SI
	INC [IBC]

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
INXD:
	INC SI
	INC [IDE]

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
INXH:
	INC SI
	INC [IHL]

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
DCXSP:
	INC SI
	DEC [ISP]

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
DCXB:
	INC SI
	DEC [IBC]
	LAHF

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
DCXD:
	INC SI
	DEC [IDE]

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
DCXH:
	INC SI
	DEC [IHL]

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
SBI80:
	MOV CL,[SI+1]
	SAHF
	SBB [IA],CL
	LAHF
	ADD SI,2

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------

DADB:
	INC SI
	MOV DX,[IBC]
	ADD [IHL],DX
	RCR DL
	SAHF
	RCL DL
	LAHF

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------

DADD:
	INC SI
	MOV DX,[IDE]
	ADD [IHL],DX
	RCR DL
	SAHF
	RCL DL
	LAHF

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------

DADH:
	INC SI
	MOV DX,[IHL]
	ADD [IHL],DX
	RCR DL
	SAHF
	RCL DL
	LAHF

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------

DADSP:
	INC SI
	MOV DX,[ISP]
	ADD [IHL],DX
	RCR DL
	SAHF
	RCL DL
	LAHF

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------

DAA80:
	MOV AL,[IA]
	SAHF
	DAA
	MOV [IA],AL
	LAHF
	INC SI

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------

ANAB:
	INC SI
	MOV DL,[IB]
	SAHF
	AND [IA],DL
	LAHF

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------

ANAC:
	INC SI
	MOV DL,[IC]
	SAHF
	AND [IA],DL
	LAHF

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------

ANAD:
	INC SI
	MOV DL,[ID]
	SAHF
	AND [IA],DL
	LAHF

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------

ANAE:
	INC SI
	MOV DL,[IE]
	SAHF
	AND [IA],DL
	LAHF

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------

ANAH:
	INC SI
	MOV DL,[IH]
	SAHF
	AND [IA],DL
	LAHF

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------

ANAL:
	INC SI
	MOV DL,[IL]
	SAHF
	AND [IA],DL
	LAHF

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------

ANAM:
	INC SI
	MOV BX,[IHL]
	MOV DL,[BX]
	SAHF
	AND [IA],DL
	LAHF

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------

ANAA:
	INC SI
	MOV DL,[IA]
	SAHF
	AND [IA],DL
	LAHF

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------


ANI80:
	MOV DL,[SI+1]
	AND [IA],DL
	LAHF
	ADD SI,2

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------

XRAB:
	INC SI
	MOV DL,[IB]
	SAHF
	XOR [IA],DL
	LAHF

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------

XRAC:
	INC SI
	MOV DL,[IC]
	SAHF
	XOR [IA],DL
	LAHF

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------

XRAD:
	INC SI
	MOV DL,[ID]
	SAHF
	XOR [IA],DL
	LAHF

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------

XRAE:
	INC SI
	MOV DL,[IE]
	SAHF
	XOR [IA],DL
	LAHF

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------

XRAH:
	INC SI
	MOV DL,[IH]
	SAHF
	XOR [IA],DL
	LAHF

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------

XRAL:
	INC SI
	MOV DL,[IL]
	SAHF
	XOR [IA],DL
	LAHF

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------

XRAM:
	INC SI
	MOV BX,[IHL]
	MOV DL,[BX]
	SAHF
	XOR [IA],DL
	LAHF

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------

XRAA:
	INC SI
	MOV DL,[IA]
	SAHF
	XOR [IA],DL
	LAHF

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------


XRI80:
	MOV DL,[SI+1]
	XOR [IA],DL
	LAHF
	ADD SI,2

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------

ORAB:
	INC SI
	MOV DL,[IB]
	SAHF
	OR [IA],DL
	LAHF

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------

ORAC:
	INC SI
	MOV DL,[IC]
	SAHF
	OR [IA],DL
	LAHF

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------

ORAD:
	INC SI
	MOV DL,[ID]
	SAHF
	OR [IA],DL
	LAHF

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------

ORAE:
	INC SI
	MOV DL,[IE]
	SAHF
	OR [IA],DL
	LAHF

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------

ORAH:
	INC SI
	MOV DL,[IH]
	SAHF
	OR [IA],DL
	LAHF

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------

ORAL:
	INC SI
	MOV DL,[IL]
	SAHF
	OR [IA],DL
	LAHF

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------

ORAM:
	INC SI
	MOV BX,[IHL]
	MOV DL,[BX]
	SAHF
	OR [IA],DL
	LAHF

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------

ORAA:
	INC SI
	MOV DL,[IA]
	SAHF
	OR [IA],DL
	LAHF

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------

ORI80:
	MOV DL,[SI+1]
	OR [IA],DL
	LAHF
	ADD SI,2

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------

CMPB:
	INC SI
	MOV DL,[IB]
	SAHF
	CMP [IA],DL
	LAHF

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------

CMPC:
	INC SI
	MOV DL,[IC]
	SAHF
	CMP [IA],DL
	LAHF

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------

CMPD:
	INC SI
	MOV DL,[ID]
	SAHF
	CMP [IA],DL
	LAHF

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------

CMPE:
	INC SI
	MOV DL,[IE]
	SAHF
	CMP [IA],DL
	LAHF

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------

CMPH:
	INC SI
	MOV DL,[IH]
	SAHF
	CMP [IA],DL
	LAHF

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------

CMPL:
	INC SI
	MOV DL,[IL]
	SAHF
	CMP [IA],DL
	LAHF

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------

CMPM:
	INC SI
	MOV BX,[IHL]
	MOV DL,[BX]
	SAHF
	CMP [IA],DL
	LAHF

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------

CMPA:
	INC SI
	MOV DL,[IA]
	SAHF
	CMP [IA],DL
	LAHF

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------

CPI80:
	MOV DL,[SI+1]
	ADD SI,2
	CMP [IA],DL
	LAHF

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
RLC80:
	INC SI
	SAHF
	ROL B,[IA]
	LAHF

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
RRC80:
	INC SI
	SAHF
	ROR B,[IA]
	LAHF

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
RAL80:
	INC SI
	SAHF
	RCL B,[IA]
	LAHF

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
RAR80:
	INC SI
	SAHF
	RCR B,[IA]
	LAHF

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
CMA80:
	INC SI
	XOR [IA],0FFH

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
CMC80:
	INC SI
	SAHF
	CMC
	LAHF

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
STC80:
	INC SI
	SAHF
	CLC
	CMC
	LAHF

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
JNZ80:
	SAHF
	JNZ JMP80
	ADD SI,3

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
JZ80:
	SAHF
	JZ JMP80
	ADD SI,3

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
JNC80:
	SAHF
	JNC JMP80
	ADD SI,3

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
JC80:
	SAHF
	JC JMP80
	ADD SI,3

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
JMP80:
	MOV SI,[SI+1]

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
JPO80:
	SAHF
	JPO JMP80
	ADD SI,3

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
JPE80:
	SAHF
	JPE JMP80
	ADD SI,3

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
JP80:
	SAHF
	JNS JMP80
	ADD SI,3

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
JM80:
	SAHF
	JS JMP80
	ADD SI,3

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
CNZ80:
	SAHF
	JNZ CALL80
	ADD SI,3

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
CZ80:
	SAHF
	JZ CALL80
	ADD SI,3

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
CNC80:
	SAHF
	JNC CALL80
	ADD SI,3

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
CC80:
	SAHF
	JC CALL80
	ADD SI,3

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
CALL80:
	MOV BX,[ISP]
	SUB BX,2
	MOV [ISP],BX
	ADD SI,3
	MOV [BX],SI
	MOV SI,[SI-2]

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
CPO80:
	SAHF
	JPO CALL80
	ADD SI,3

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
CPE80:
	SAHF
	JPE CALL80
	ADD SI,3

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
CP80:
	SAHF
	JNS CALL80
	ADD SI,3

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
CM80:
	SAHF
	JS CALL80
	ADD SI,3

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
RNZ80:
	INC SI
	SAHF
	JNZ XRET
	LAHF

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
RZ80:
	INC SI
	SAHF
	JZ XRET
	LAHF

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
RNC80:
	INC SI
	SAHF
	JNC XRET
	LAHF

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
RC80:
	INC SI
	SAHF
	JC XRET
	LAHF

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
XRET:
	MOV BX,[ISP]
	MOV SI,[BX]
	ADD BX,2
	MOV [ISP],BX

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
RPO80:
	INC SI
	SAHF
	JPO XRET
	LAHF

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
RPE80:
	INC SI
	SAHF
	JPE XRET
	LAHF

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
RP80:
	INC SI
	SAHF
	JNS XRET
	LAHF

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
RM80:
	INC SI
	SAHF
	JS XRET
	LAHF

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------

RST0:
	MOV BX,[ISP]
	SUB BX,2
	MOV [ISP],BX
	MOV [BX],SI
	ADD W,[BX],1
	MOV SI,00H

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------

RST1:
	MOV BX,[ISP]
	SUB BX,2
	MOV [ISP],BX
	MOV [BX],SI
	ADD W,[BX],1
	MOV SI,08H

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------

RST2:
	MOV BX,[ISP]
	SUB BX,2
	MOV [ISP],BX
	MOV [BX],SI
	ADD W,[BX],1
	MOV SI,10H

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------

RST3:
	MOV BX,[ISP]
	SUB BX,2
	MOV [ISP],BX
	MOV [BX],SI
	ADD W,[BX],1
	MOV SI,18H

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------

RST4:
	MOV BX,[ISP]
	SUB BX,2
	MOV [ISP],BX
	MOV [BX],SI
	ADD W,[BX],1
	MOV SI,20H

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------

RST5:
	MOV BX,[ISP]
	SUB BX,2
	MOV [ISP],BX
	MOV [BX],SI
	ADD W,[BX],1
	MOV SI,28H

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------

RST6:
	MOV BX,[ISP]
	SUB BX,2
	MOV [ISP],BX
	MOV [BX],SI
	ADD W,[BX],1
	MOV SI,30H

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------

RST7:
	MOV BX,[ISP]
	SUB BX,2
	MOV [ISP],BX
	MOV [BX],SI
	ADD W,[BX],1
	MOV SI,38H

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------

PCHL:
	MOV SI,[IHL]

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
PUSHPSW:
	MOV [IFLAGS],AH
	MOV BX,[ISP]
	SUB BX,2
	MOV [ISP],BX
	MOV DL,[IFLAGS]
	MOV DH,[IA]
	MOV [BX],DX
	INC SI

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
PUSHB:
	MOV DX,[IBC]
	MOV BX,[ISP]
	SUB BX,2
	MOV [BX],DX
	MOV [ISP],BX
	INC SI

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------

PUSHD:
	MOV DX,[IDE]
	MOV BX,[ISP]
	SUB BX,2
	MOV [BX],DX
	MOV [ISP],BX
	INC SI

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------

PUSHH:
	MOV DX,[IHL]
	MOV BX,[ISP]
	SUB BX,2
	MOV [BX],DX
	MOV [ISP],BX
	INC SI

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
POPPSW:
	MOV BX,[ISP]
	MOV DX,[BX]
	MOV [IFLAGS],DL
	MOV [IA],DH
	ADD BX,2
	MOV [ISP],BX
	INC SI
	MOV AH,[IFLAGS]

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
POPB:
	MOV BX,[ISP]
	MOV DX,[BX]
	MOV [IBC],DX
	ADD [ISP],2
	INC SI

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------

POPD:
	MOV BX,[ISP]
	MOV DX,[BX]
	MOV [IDE],DX
	ADD [ISP],2
	INC SI

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------

POPH:
	MOV BX,[ISP]
	MOV DX,[BX]
	MOV [IHL],DX
	ADD [ISP],2
	INC SI

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------

XTHL:
	MOV BX,[ISP]
	MOV DX,[BX]
	MOV CX,[IHL]
	MOV [BX],CX
	MOV [IHL],DX
	INC SI

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------
SPHL:
	MOV BX,[IHL]
	MOV [ISP],BX
	INC SI

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------

HLT80:
	JMP DONE	;RUN THIS INSTRUCTION FOREVER

IN80:
	MOV DH,0
	MOV DL,[SI+1]
	INB DX
	MOV [IA],AL
	ADD SI,2

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------


OUT80:	MOV DH,0
	MOV DL,[SI+1]
	MOV AL,[IA]
	OUTB DX		; SEE IF THIS WORKS TOO
	ADD SI,2

	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;--------------------------------


;

Z8008:
	MOV AL,08H
	JMP Z80ERROR
Z8010:
	MOV AL,10H
	JMP Z80ERROR
Z8018:
	MOV AL,18H
	JMP Z80ERROR
Z8020:
	MOV AL,20H
	JMP Z80ERROR
Z8028:
	MOV AL,28H
	JMP Z80ERROR
Z8030:
	MOV AL,30H
	JMP Z80ERROR
Z8038:
	MOV AL,38H
	JMP Z80ERROR
Z80CB:
	MOV AL,0CBH
	JMP Z80ERROR
Z80D9:
	MOV AL,0D9H
	JMP Z80ERROR
Z80DD:
	MOV AL,0DDH
	JMP Z80ERROR
Z80ED:
	MOV AL,0EDH
	JMP Z80ERROR
Z80FD:
	MOV AL,0FDH
	JMP Z80ERROR

;
Z80ERROR:
	PUSH AX
	MOV DL,CR
	MOV AH,2
	INT 21H
	MOV DL,LF
	MOV AH,2
	INT 21H
	MOV DL,BELL
	MOV AH,2
	INT 21H
	POP AX
	CALL PRTBYTE

	PUSH DS
	MOV BX,CS
	MOV DS,BX
	MOV DX,Z80MSG
	MOV AH,09H
	INT 21H
	POP DS

	CALL DEBUG
	JMP USERBOOT

;
Z80MSG:
	DB ' <- Invalid Operation Code encountered ***',BELL,CR,LF,'$'
;
;

;INTERRUPT CONTROL DISALLOWED
EI80:
DI80:

NOP80:
	INC SI
	SAHF
	JMP DONE
;

;
SOMEBUG:
	PUSHF
	PUSH AX
	MOV AL,[BUGFLG]
	OR AL,AL
	JZ ENDSOME
	CALL DEBUG
ENDSOME:
	POP AX
	POPF
	RET
;
;
DEBUG:
	PUSH AX
	PUSHF
	PUSH BX
	PUSH CX
	PUSH DX
;
	JMP NOTYET2	;TRACE ALL
;
	MOV AL,[IC]
	CMP AL,15H
	JNZ NOTYET
	NOP
NOTYET:
	CMP AL,0FH
	JNZ NOTYET2
	NOP
NOTYET2:
;
	MOV DL,CR
	MOV AH,2
	INT 21H
	MOV DL,LF
	MOV AH,2
	INT 21H

	MOV [IFLAGS],AH
	MOV BX,SI
	CALL PRTWORD
	MOV BH,[IFLAGS]
	MOV BL,[IA]
	CALL PRTWORD
	MOV BX,[IBC]
	CALL PRTWORD
	MOV BX,[IDE]
	CALL PRTWORD
	MOV BX,[IHL]
	CALL PRTWORD
	MOV BX,[ISP]
	CALL PRTWORD
;
	MOV AL,[SI]
	CALL PRTBYTE

    IF NO
	MOV DL,CR
	MOV AH,2
	INT 21H
	MOV DL,LF
	MOV AH,2
	INT 21H
    ENDIF

	POP DX
	POP CX
	POP BX
	POPF
	POP AX
	RET
;
PRTWORD:
	MOV AL,BH
	CALL PRTBYTE
	MOV AL,BL
	CALL PRTBYTE
	MOV AH,2
	MOV DL,' '
	INT 21H
	RET
;
PRTBYTE:
	PUSH DX
	PUSH BX
	MOV BL,AL
	ROR BL
	ROR BL
	ROR BL
	ROR BL
	AND BL,0FH
	CALL HEX2A
	MOV DL,BL
	PUSH AX
	MOV AH,2
	INT 21H
	POP AX
	MOV BL,AL
	AND BL,0FH
	CALL HEX2A
	MOV DL,BL
	MOV AH,2
	INT 21H
	POP BX
	POP DX
	RET
;
HEX2A:
	ADD BL,30H
	CMP BL,39H
	JLE HEXN
	ADD BL,07H
HEXN:	RET
;

;
;
BITMASK	DB 0	;TEMP STORAGE OF INT MASK
	DB 0
;
;
; PROGRAM TEMPORARY FCB TO READ COM FILE
;
FCB:
	DB 0,0,0,0,0,0,0
	DB 0,0,0,0,0,0,0
	DB 0,0,0,0,0,0,0
	DB 0,0,0,0,0,0,0
	DB 0,0,0,0,0,0,0
	DB 0,0,0,0
;
;
;
; MAP OUT REAL CPM SYSTEM
;
;
BOOT:	DB 0C3H,03H,0FAH

IOBYTE:	DB 094H

USRBYT:	DB 00H

BDOS:	DB 0C3H,06H,0ECH
	DS 54H
	DB 00H,20H,20H,20H
	DS 0A0H
TBA:
	DB 76H
;
;
;
REALBDOS:
	DW 00EDH	; DECODE BDOS CALLS
	DB 0C9H
	DW 0
;
;
; CPM JUMP TABLE
; (FOR THOSE WHO NEED TO SEE A JUMP TABLE HERE) 
;
CPMJMP:
	DB 0C3H
	DW 0FB00H	;CBOOT
;
	DB 0C3H
	DW 0FB03H	;WBOOT
;
	DB 0C3H
	DW 0FB06H	;CONST
;
	DB 0C3H
	DW 0FB09H	;CONIN
;
	DB 0C3H
	DW 0FB0CH	;CONOUT
;
	DB 0C3H
	DW 0FB0FH	;LIST
;
	DB 0C3H
	DW 0FB12H	;PUNCH
;
	DB 0C3H
	DW 0FB15H	;READER
;
	DB 0C3H
	DW 0FB18H	;HOME
;
	DB 0C3H
	DW 0FB1BH	;SELDSK
;
	DB 0C3H
	DW 0FB1EH	;SETTRK
;
	DB 0C3H
	DW 0FB21H	;SETSEC
;
	DB 0C3H
	DW 0FB24H	;SETDMA
;
	DB 0C3H
	DW 0FB27H	;READ
;
	DB 0C3H
	DW 0FB2AH	;WRITE
;
	DB 0C3H
	DW 0FB2DH	;LISTST
;
	DB 0C3H
	DW 0FB30H	;SECTRAN

;
;NOW CONVERT TO OUR OWN CONTROL VIA MACRO COMMAND
;

CBOOT:	DW 01EDH		;0FB00H
	DB 0C9H

WBOOT:	DW 02EDH		;0FB03H
	DB 0C9H

CONST:	DW 03EDH		;0FB06H
	DB 0C9H

CONIN:	DW 04EDH		;0FB09H
	DB 0C9H

CONOUT:	DW 05EDH		;0FB0CH
	DB 0C9H

LIST:	DW 06EDH		;0FB0FH
	DB 0C9H

PUNCH:	DW 07EDH		;0FB12H
	DB 0C9H

READER:	DW 08EDH		;0FB15H
	DB 0C9H

HOME:	DW 09EDH		;0FB18H
	DB 0C9H

SELDSK:	DW 0AEDH		;0FB1BH
	DB 0C9H

SETTRK:	DW 0BEDH		;0FB1EH
	DB 0C9H

SETSEC	DW 0CEDH		;0FB21H
	DB 0C9H

SETDMA:	DW 0DEDH		;0FB24H
	DB 0C9H

READ:	DW 0EEDH		;0FB27H
	DB 0C9H

WRITE:	DW 0FEDH		;0FB2AH
	DB 0C9H

LISTST:	DW 10EDH		;0FB2DH
	DB 0C9H

SECTRAN: DW 11EDH		;0FB30H
	DB 0C9H



;*****************************************
; END OF BIOS SECTION
;***************************************
;
;
; STACK AREA HERE
;
	DS 400H
STACK	EQU $
;
;
;
;
;  8080 REGISTERS MAPPED INTO MEMORY
;
	DS 0FC00H-$
;
IBC:
IC:	DS 1
IB:	DS 1
;
IDE:
IE:	DS 1
ID:	DS 1
;
IHL:
IL:	DS 1
IH:	DS 1
;
IPSW:
IFLAGS:	DS 1
IA:	DS 1
;
ISP:	DS 2
;
	DS 2	;EXTRA
DMA	DS 2	;DMA ADDRESS
;
CPMEND:
	DS 2
;
BUGFLG:
	DS 1
	DS 1	;SAFETY
;

BYTEIN:
	DS 1

BYTERDYFLG:
	DS 1
	DS 1
COMBRDYFLG:
	DS 1
	DS 1

COMBYTEIN:
	DS 1
	DS 1
GETIN:
	DS 1
	DS 1
STRDY:
	DS 1
	DS 1


PRTFLAG:
	DS 1
	DS 1
SPCOUNT:
	DS 1
	DS 1

DRVLOG:
	DS 2	;DRV SEL FLAG


CURFLAG:
	DS 1
	DS 1

EQFLAG:
	DS 1
	DS 1

ROWFLAG:
	DS 1
	DS 1

ROWCNT:
	DS 1
	DS 1

LASTXY:
	DS 2 

CONFLAG:
	DS 1
	DS 1

BEGBUFF:
	DS 1
	DS 1

DELCOUNT:
	DS 1
	DS 1

DISKREG:
	DS 1
	DS 1

DMAFLAG:
	DS 1
	DS 1

OLDBUGVAL:
	DS 1
	DS 1


;
TEMPFCB:
	DS 48
	DS 32
DPARM:
	DS 16
ALLOC:
	DS 256

	DS 32	;CPM STACK
CPMSTACK:
	DS 4	;BEG OF CPM STACK


	END 100H
